------------------------------------------------------------
-- FN1241 t[GV^f[^ԃtB^23bito͎
-- PCM1704 DAC 24bit͏o
-- f[^ϊjbg
-- XC2C64A-7VQG44C[Xlinx]
-- In_FN1241_FO.vhd
-- 10-Aug.-2009 Y.Kuroda  RATOC Systems,Inc.
-- 11-Aug.-2009 debug
-- 18-Aug.-2009 debug2 64clk
-- 19-Aug.-2009 debug3 23bit24bitŏo SDOL FCKOLւ
-- 20-Aug.-2009 release
-- 22-Jun.-2022 o͂64clkł͂Ȃ 32clkɕύXB
-- 29-Jun.-2022 RgC
------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity In_FN1241_FO is
	generic (
		cSDOL_Size:	integer :=22;		-- SDOL  ̃rbg(n-1)
		cFCKOL_Fs:		integer :=63	-- FCKOL ̃NbN(m-1)
	);
	port (
		
		SCLK_i:			in		std_logic;									-- Master(System) Clock 512fs(fs=32 or 44.1 or 48MHz)
		     			  		          									--  ->(16.384/22.5792/24.576MHz)
		SDOL:			in		std_logic;									-- Serial Data Input
		FCKOL:			in		std_logic;									-- Word Clock 64fs ?? one shot
		
		BCLK:			out		std_logic;									-- Bit Clock out
		WCLK:			out		std_logic;									-- Word Clock out
		SDOUT:			out		std_logic;									-- Serial Data Output
		
		RESET:			in		std_logic						-- Reset L:Reset
	);
	attribute FLOAT: string;	-- "TRUE" or "FALSE" pbhɑ΂đŜPullUpKEEPERݒ肳ĂƂFLOAT悤ݒ肷
	attribute FLOAT of SCLK_i:		signal is "TRUE";
	attribute FLOAT of SDOL:		signal is "TRUE";
	attribute FLOAT of FCKOL:		signal is "TRUE";
	attribute FLOAT of BCLK:		signal is "TRUE";
	attribute FLOAT of WCLK:		signal is "TRUE";
	attribute FLOAT of SDOUT:		signal is "TRUE";
	attribute FLOAT of RESET:		signal is "TRUE";
	attribute SCHMITT_TRIGGER: string;	-- "TRUE" or "FALSE" ̓pbhV~bggKɐݒ肷
	attribute SCHMITT_TRIGGER of SCLK_i:		signal is "TRUE";
	attribute SCHMITT_TRIGGER of SDOL:		signal is "TRUE";
	attribute SCHMITT_TRIGGER of FCKOL:		signal is "TRUE";
	attribute SCHMITT_TRIGGER of RESET:		signal is "TRUE";
	attribute PIN_ASSIGN: string;	-- šŒ
	attribute PIN_ASSIGN of SCLK_i:		signal is "P1";
	attribute PIN_ASSIGN of SDOL:		signal is "P2";
	attribute PIN_ASSIGN of FCKOL:		signal is "P3";
	attribute PIN_ASSIGN of BCLK:		signal is "P28";
	attribute PIN_ASSIGN of WCLK:		signal is "P27";
	attribute PIN_ASSIGN of SDOUT:		signal is "P29";
	attribute PIN_ASSIGN of RESET:		signal is "P30";
end In_FN1241_FO;

architecture In_FN1241_FO_arc of In_FN1241_FO is
	
	signal	SCLK:				std_logic;								-- 
	signal	SDOL_qf:			std_logic;								-- SDOL ̔Y
	signal	Counter:			integer range 0 to (cFCKOL_Fs + 1);		-- 
	signal	S2p:				std_logic_vector(cSDOL_Size downto 0);	-- Serial to Palarel Data 23bits Non Lacth
	signal	F_Valid:			std_logic;								-- 
	signal	FIFO:				std_logic_vector(cSDOL_Size downto 0);	-- Palarel Data 23bits
	signal	SDOUT_qf:			std_logic;								-- SDOUT ̔Y
	signal	BCLK_o:				std_logic;								-- BCLKo͗p
	
begin
	
	SCLK <= SCLK_i;
	
	-- Serial Data Shift count
	process(SCLK, RESET)
	begin
		if (RESET='0') then
			Counter <= 0;
			F_Valid <= '0';	-- tONA
		elsif (SCLK'event and SCLK = '0') then	-- SCLK tGbW
			if (FCKOL = '1') then
				Counter <= 0;	-- FCK SDOLŃNA
				F_Valid <= '1';	--tOZbg
			elsif ( Counter = (cSDOL_Size + 1) ) then
				Counter <= Counter + 1;	-- JEgAbv
				F_Valid <= '0';	-- tONA
			elsif ( Counter = (cFCKOL_Fs + 1) ) then	-- 2022.06.23
				Counter <= Counter;	-- JEgXgbv
				F_Valid <= '0';	-- tONA
			else
				Counter <= Counter + 1;	-- JEgAbv
				F_Valid <= '0';	-- tONA
			end if;
		end if;
	end process;
	
	-- SDOL 𔼎x炷
	process(SCLK, RESET)
	begin
		if (RESET='0') then
			SDOL_qf <= '0';
		elsif (SCLK'event and SCLK = '0') then	-- SCLK tGbW
			SDOL_qf <= SDOL;
		end if;
	end process;
	
	-- Serial Data Latch
	process(SCLK, RESET)
	begin
		if (RESET='0') then
			S2p <= (others => '0');
		elsif (SCLK'event and SCLK = '1') then	-- SCLK GbW
			for i in 0 to cSDOL_Size loop
				if (Counter = i) then
					S2p(i) <= SDOL_qf;
				end if;
			end loop;
		end if;
	end process;
	
	-- Paralel Data Latch
	process(SCLK, RESET)
	begin
		if (RESET='0') then
			FIFO <= (others => '0');
		elsif (SCLK'event and SCLK = '1') then	-- SCLK GbW
			if (F_Valid = '1') then
				FIFO <= S2p;
			end if;
		end if;
	end process;
	
	-- SDOUT_qf̐
	process(SCLK, RESET)
	begin
		if (RESET='0') then
			SDOUT_qf <= '0';
		elsif (SCLK'event and SCLK = '1') then	-- SCLK GbW
-- 2022.06.22 vvRgAEg 64clk -> 32clk֕ύX̂
---			SDOUT_qf <= '0';
---			for i in 0 to cSDOL_Size loop
--				if (Counter = ( i + (cFCKOL_Fs - cSDOL_Size - 1) ) ) then	-- 2022.06.22
--					-- 64bitMSB LSBϊ
--					-- Lf[^23bit24bit邽1clkVtg
--					SDOUT_qf <= FIFO(cSDOL_Size - i);
--				end if;	-- 2022.06.22
---			end loop;
-- 2022.06.22 ^^RgAEg 64clk -> 32clk֕ύX̂
			-- 2022.06.22 64clk->32clko͂ւ̕ύXɔ2clk̃VAf[^ƂB
			-- Lf[^23bit24bit邽1clkVtg
			-- 64bit2 MSB LSBϊ 1clkڂ2clk Counter=16or17, 18or19.. 60or61
			if    ( (Counter = 16) or (Counter = 17) ) then
				SDOUT_qf <= FIFO(22);
			elsif ( (Counter = 18) or (Counter = 19) ) then
				SDOUT_qf <= FIFO(21);
			elsif ( (Counter = 20) or (Counter = 21) ) then
				SDOUT_qf <= FIFO(20);
			elsif ( (Counter = 22) or (Counter = 23) ) then
				SDOUT_qf <= FIFO(19);
			elsif ( (Counter = 24) or (Counter = 25) ) then
				SDOUT_qf <= FIFO(18);
			elsif ( (Counter = 26) or (Counter = 27) ) then
				SDOUT_qf <= FIFO(17);
			elsif ( (Counter = 28) or (Counter = 29) ) then
				SDOUT_qf <= FIFO(16);
			elsif ( (Counter = 30) or (Counter = 31) ) then
				SDOUT_qf <= FIFO(15);
			elsif ( (Counter = 32) or (Counter = 33) ) then
				SDOUT_qf <= FIFO(14);
			elsif ( (Counter = 34) or (Counter = 35) ) then
				SDOUT_qf <= FIFO(13);
			elsif ( (Counter = 36) or (Counter = 37) ) then
				SDOUT_qf <= FIFO(12);
			elsif ( (Counter = 38) or (Counter = 39) ) then
				SDOUT_qf <= FIFO(11);
			elsif ( (Counter = 40) or (Counter = 41) ) then
				SDOUT_qf <= FIFO(10);
			elsif ( (Counter = 42) or (Counter = 43) ) then
				SDOUT_qf <= FIFO(9);
			elsif ( (Counter = 44) or (Counter = 45) ) then
				SDOUT_qf <= FIFO(8);
			elsif ( (Counter = 46) or (Counter = 47) ) then
				SDOUT_qf <= FIFO(7);
			elsif ( (Counter = 48) or (Counter = 49) ) then
				SDOUT_qf <= FIFO(6);
			elsif ( (Counter = 50) or (Counter = 51) ) then
				SDOUT_qf <= FIFO(5);
			elsif ( (Counter = 52) or (Counter = 53) ) then
				SDOUT_qf <= FIFO(4);
			elsif ( (Counter = 54) or (Counter = 55) ) then
				SDOUT_qf <= FIFO(3);
			elsif ( (Counter = 56) or (Counter = 57) ) then
				SDOUT_qf <= FIFO(2);
			elsif ( (Counter = 58) or (Counter = 59) ) then
				SDOUT_qf <= FIFO(1);
			elsif ( (Counter = 60) or (Counter = 61) ) then
				SDOUT_qf <= FIFO(0);
			else
				SDOUT_qf <= '0';
			end if;
		end if;
	end process;
	
	-- SDOUT_qf 𔼎x炷
	process(SCLK, RESET)
	begin
		if (RESET='0') then
			SDOUT <= '0';
		elsif (SCLK'event and SCLK = '0') then	-- SCLK tGbW
			SDOUT <= SDOUT_qf;
		end if;
	end process;
	
	-- Bit Clock Output
--	BCLK <= SCLK;	-- 2022.06.22
	-- 2022.06.22 oCpX番ɕύX
	process(SCLK, RESET)
	begin
		if (RESET='0') then
			BCLK_o <= '0';
		elsif (SCLK'event and SCLK = '0') then	-- SCLK tGbW
			BCLK_o <= not BCLK_o;
		end if;
	end process;
	BCLK <= not BCLK_o;
	
	-- Word Clock
	process(SCLK, RESET)
	begin
		if (RESET='0') then
			WCLK <= '0';
		elsif (SCLK'event and SCLK = '0') then	-- SCLK GbW
			if (Counter <= (cFCKOL_Fs / 2) ) then
				WCLK <= '0';
			else
				WCLK <= '1';
			end if;
		end if;
	end process;
	
	
	-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	--                                                                                                                                                                                                                                         
	--              //////////// 
	--  SCLK    //////////// 
	--                                                                                                                                                                                                                       
	--  FCK       //////  //////   
	--              //                                              //                                               
	--  SDOL         0 1 2 3  1516171819202122Valid-1                                      0 1 2 3  1516171819202122Valid-2                                      0 1 2 3 
	--          //////////// 
	--                                                                                                                                                                                                                                         
	--                                                                                                                                                                                                                                         
	--                //                                              //                                               
	--  SDOL_QF        0 1 2      1516171819202122Valid-1                                      0 1 2      1516171819202122Valid-2                                      0 1 2   
	--          //////////// 
	--                /////////////
	--  Counter        0 1 2      151617181920212223      32      585960616263 0 1 2      151617181920212223      32      585960616263 0 1 2   
	--          /////////////
	--          //////////// 
	--  S2p     Valid-0 NotValid                                      Valid-1                                           NotValid                                      Valid-2                                           NotValid     
	--          //////////// 
	--                                                                                                                                                                                                                       
	--  F_Valid   //////  //////   
	--                  //////////// 
	--  FIFO            Valid-0                                                                                           Valid-1                                                                                           Valid-2      
	--          //////////// 
	--                                          //  //                      //  //             
	--  SDOUT_qf                                22    21    20    19                     2     1     L    Valid-0             22    21    20    19                     2     1     L    Valid-1    
	--          //////////// 
	--                                                                                                                                                                                                                                         
	--                                                                                                                                                                                                                                         
	--                    //          //                  //          //                  /
	--  BCLK        //            //  //          //            //  //          /
	--                                                                                    //                                                              //           
	--  WCLK    ////                                  ////                                   
	--                                                                                                                                                                                                                                         
	--                                            ////                      ////           
	--  SDOUT                                     22    21    20    19                       2     1     L    Valid-0             22    21    20    19                       2     1     L    Valid-1  
	--          //////////// 
	--                                                                                                                                                                                                                                         
	-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	
end In_FN1241_FO_arc;
